<?PHP
	include('include/globals.php');

	if (($_SESSION['spellenable'] == 1) && (!is_file($_SESSION['spellcommand']))) {
		echo("<HTML><HEAD><TITLE>Error</TITLE></HEAD><BODY>\n");
		echo("	" . gettext("Please have your system administrator check the path to the spelling program.") . "\n");
		echo("</BODY></HTML>\n");
		exit;
	}

	// get the text and resubmit if we are passing it in as a get string
	if(isset($_GET["textareaid"]) and $_GET["textareaid"] != '') {
		echo("<html>\n");
		echo("	<head>\n");
		echo("		<title>" . gettext("Check Spelling") . "</title>\n");
		echo("	</head>\n");
		echo("	<body>\n");
		echo("		<form method=\"post\" action=\"spellcheck.php\" id=\"resubmitform\" name=\"resubmitform\">\n");
		echo("			<input type=\"hidden\" id=\"textareaid\" name=\"textareaid\" value=\"" . htmlspecialchars($_GET["textareaid"]) . "\">\n");
		echo("			<input type=\"hidden\" id=\"spellcheck\" name=\"spellcheck\">\n");
		echo("		</form>\n");
		echo("		<table align=\"center\" style=\"height: 100%\">\n");
		echo("			<tr>\n");
		echo("				<td>\n");
		echo("					" . gettext("Checking Spelling") . "...\n");
		echo("				</td>\n");
		echo("			</tr>\n");
		echo("		</table>\n");
		echo("		<script type=\"text/javascript\">\n");
		echo("			document.getElementById('spellcheck').value = opener.document.getElementById('" . addslashes($_GET["textareaid"]) . "').value;\n");
		echo("			document.resubmitform.submit();\n");
		echo("		</script>\n");
		echo("	</body>\n");
		echo("</html>\n");
		exit;
	}

	if(isset($_POST['spellsubmit']) && $_POST['spellsubmit'] != '') {
		$final = '';
		$chunkcount = 0;
		while(1 == 1) {
			$chunk = "chunk" . $chunkcount;
			if(!isset($_POST[$chunk])) {
				break;
			}
			$final = $final . $_POST[$chunk];
			if(isset($_POST['break' . $chunkcount])) {
				$final = $final . "\n";
			}
			$word = "word" . $chunkcount;
			if(isset($_POST[$word])) {
				$final = $final . $_POST[$word];
			}
			$chunkcount = $chunkcount + 1;
		}

		echo("<html>\n");
		echo("	<head>\n");
		echo("		<title>" . gettext("Check Spelling") . "</title>\n");
		echo("	</head>\n");
		echo("	<body>\n");
		echo("		<script type=\"text/javascript\">\n");
		echo("			opener.document.getElementById('" . addslashes($_POST["textareaid"]) . "').value = '" . str_replace("\n", '\n', str_replace("\r", "bob", addslashes($final))) . "';\n");
		echo("			window.close();\n");
		echo("		</script>\n");
		echo("	</body>\n");
		echo("</html>\n");
		exit;
	}

	// make a descriptor array to tell the child process where to read and write to/from
	if(function_exists('proc_open')) {
		$descriptorspec = array(0 => array("pipe", "r"), 1 => array("pipe", "w"), 2=> array("pipe", "w"));

		$process = proc_open($_SESSION['spellcommand'] . " " . $_SESSION['spellargs'], $descriptorspec, $pipes);

		// pipe the text to be checked to the spelling check program
		fwrite($pipes[0], $_POST["spellcheck"]);
		fclose($pipes[0]);

		// read the response
		$response = "";
		while(!feof($pipes[1])) {
			$response = $response . fgets($pipes[1]);
		}
		fclose($pipes[1]);

		// read stderr - we currently don't use this for anything but leave it in for ease of debugging
		$errors = "";
		while(!feof($pipes[2])) {
			$errors = $errors . fgets($pipes[2]);
		}
		fclose($pipes[2]);

		$return_value = proc_close($process);
	}
	else {
		// PHP < 4.3.0 does not have a proc_open to handle reading and writing so we need to
		// dump it into a temporary file and read it back in to avoid popen's limitations

		$outputfile = tempnam("users/" . md5($_SESSION["emailaddress"]) . "/", "spell");
		$process_handle = popen($_SESSION['spellcommand'] . " " . $_SESSION['spellargs'] . " > " . $outputfile, 'w');

		// pipe the text to be checked to the spelling check program
		fwrite($process_handle, $_POST["spellcheck"]);
		fclose($process_handle);

		// read the response
		$response = "";
		$fp = fopen($outputfile, 'r');
		while(!feof($fp)) {
			$response = $response . fgets($fp);
		}
		fclose($fp);

		@unlink($outputfile);

		// set the return value artificially since we have no better way to get it
		$return_value = 0;
	}

	$haserrors = strpos($response, '&');
	$response = explode("\n", $response);

	PageHeader(1);
?>
<head>
	<title><?php echo(gettext("Check Spelling"));?></title>
</head>
<body>
	<form method="post" action="./spellcheck.php">
		<?PHP
			echo("		<input type=\"hidden\" id=\"textareaid\" name=\"textareaid\" value=\"" . htmlspecialchars($_POST["textareaid"]) . "\">\n");

			$_POST["spellcheck"] = explode("\n", $_POST["spellcheck"]);
			$end = count($response);
			$currentline = 0;
			$offset = 0;
			$hiddencount = 0;
			if($errors != "" or $return_value != 0) {
				echo("<div style=\"width: 100%; text-align: center\">\n");
				echo("	" . gettext("Unable to check spelling") . "<br>");
				echo($errors);
				echo("</div>\n");
			}
			if($haserrors === false) {
				echo("<div style=\"width: 100%; text-align: center\">\n");
				echo("	" . gettext("No spelling errors found"));
				echo("</div>\n");
			}
			else {
				for($i=1;$i<$end;$i++) {
					if($response[$i] == '') {
						echo("<input name=\"chunk" . $hiddencount . "\" type=\"hidden\" value=\"" . htmlspecialchars(trim(substr($_POST["spellcheck"][$currentline], $offset, strlen($_POST["spellcheck"][$currentline])-$offset), "\r\n")) . "\">");
						echo("<input name=\"break" . $hiddencount . "\" type=\"hidden\" value=\"true\">");
						$hiddencount = $hiddencount + 1;
						echo(nl2br(htmlspecialchars(substr($_POST["spellcheck"][$currentline], $offset, strlen($_POST["spellcheck"][$currentline])-$offset))));
						$currentline = $currentline + 1;
						$offset = 0;
					}
					elseif($response[$i][0] == '&') {
						$info = explode(':', $response[$i]);
						$words = explode(',', $info[1]);
						$info = $info[0];
						$info = explode(' ', $info);

						// print out the line up to the point of the misspelling
						echo("<input name=\"chunk" . $hiddencount . "\" type=\"hidden\" value=\"" . htmlspecialchars(substr($_POST["spellcheck"][$currentline], $offset, (int)$info[3]-$offset)) . "\">");
						$hiddencount = $hiddencount + 1;
						echo(nl2br(htmlspecialchars(substr($_POST["spellcheck"][$currentline], $offset, (int)$info[3]-$offset))));
						$offset = (int)$info[3] + strlen($info[1]);
						echo("<select name=\"word" . ($hiddencount-1) . "\">\n");
						$wend = count($words);
						echo("<option value=\"" . htmlspecialchars($info[1]) . "\">(" . htmlspecialchars($info[1]) . ")\n");
						echo("<option value=\"" . htmlspecialchars($info[1]) . "\">  --------  \n");
						for($w=0;$w<$wend;$w++) {
							echo("	<option>" . htmlspecialchars($words[$w]) . "\n");
						}
						echo("</select>\n");
					}
				}
			}
		?>
		<br>
		<div align="center">
			<?PHP
				if($haserrors !== false) {
					echo("			<input type=\"submit\" value=\" " . gettext("Fix Spelling") . " \" name=\"spellsubmit\">\n");
				}
			?>
		</div>
	</form>
</body>

</html>
